remove(list = ls())
library(stats)
getwd()

yt=function(x0,u0){
  y=x0
  y[u0<=x0]=1
  y[u0>x0]=0
  return(y)
}

Kh=function(h,t0){
  y=t0
  y[abs(t0/h)>=1]=0
  y[abs(t0/h)<1]=0.75*(1-(t0[abs(t0/h)<1]/h)^2)/h
  return(y)
}

s0=function(beta,k0,locf){
  idcova=rep(0,n)
  idcova[locf[,2]!=0]=1
  return(sum(yt(x,x[k0])*exp(beta*locf[,2])*idcova*Kh(h, x[k0]-locf[,1])))
}

s1=function(beta,k0,locf){
    return(sum(yt(x,x[k0])*exp(beta*locf[,2])*locf[,2] *Kh(h, x[k0]-locf[,1])))
}

s2=function(beta,k0,locf){
    return(sum(yt(x,x[k0])*exp(beta*locf[,2])*(locf[,2]^2)*Kh(h, x[k0]-locf[,1])))
}

fcova=function(i){
   cova=rep(0,n)
   cova_t = rep(0, n)
   for(j in 1:n){
        sik=observe[(ord[j]+1):(ord[j]+num[j])]
	  covariatei = covariate[(ord[j]+1):(ord[j]+num[j])]
	  sik[sik > x[i]] = -Inf
        neart = which.max(sik)
	  if (sik[neart]!=-Inf&&(!is.na(covariatei[neart])))
	  	{
           cova[j]=covariatei[neart] 
           cova_t[j] = sik[neart]
         }
   }
return(cbind(cova_t, cova))
}
	

basic = read.csv("dataset_317_basic.csv", header = TRUE)
long = read.csv("longitudinal.csv", header = TRUE)
count = read.csv("count.csv", header = TRUE)
count[1:10,]
basic.2 = merge(basic, count, by = "projid")
dim(basic.2)
basic.2[1:20,]
surv_time = rep(0,nrow(basic.2))
delta = rep(1, nrow(basic.2))
for ( i in 1:nrow(basic.2)){
	if (is.na(basic.2[i,5])){
		delta[i] = 0
		surv_time[i] = basic.2[i,38]
	}
	if (!is.na(basic.2[i,5])){
		surv_time[i] = basic.2[i,5] - basic.2[i,37] 
	}	
}

censoring = 1-mean(delta)
censoring
survival_pure = cbind(basic.2[,c(1, 39)], delta, surv_time)
survival_pure[1:10,]
is.numeric(survival_pure[1,2])
long[1:10,]
dim(long)
ep = long[,c(1, 21, 39)]
# ep means bmi
#ep=ep[!is.na(ep[,2]),]
is.numeric(ep[1,3])
dim(ep)
ep[1:10,]
quantile(ep[,3], 0.25)
n = nrow(survival_pure)
effn = sum(delta)
h = seq(2*(quantile(ep[,3], 0.75) - quantile(ep[,3], 0.25))*effn^(-0.7), 2*(quantile(ep[,3], 0.75) - quantile(ep[,3], 0.25))*effn^(-0.6), length = 30)
lbd = length(h)
num = survival_pure[,2]
ord = 1:n
	ord[1] = 0
	for (i in 2:n){
		ord[i] = sum(num[1:(i-1)])
	}
	observe = ep[,3]
	covariate = ep[,2]
	x = survival_pure[,4]
	
hatv = rep(0, lbd)
betahat = rep(0, lbd)
betahat.1 = rep(0, lbd)
betahat.2 = rep(0, lbd)

cvlabel = sample(rep(c(1:2), length =n ))
for (bd in 1:lbd){
	beta0 = 0.01
	sign=0
 while(sign==0){
 L1=0
 L2=0
 for (i in 1:n){
   if ((delta[i]==1)&&(num[i]>0)&&(delta[i]==1)&&(!is.na(ep[i,2]))){
     locf=fcova(i)
     if(locf[i,2]!=0){
  idcova=rep(0,n)
  idcova[locf[,2]!=0]=1
  temp0 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*idcova     *Kh(h[bd], x[i]-locf[,1])))
  temp1 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*locf[, 2]  *Kh(h[bd], x[i]-locf[,1])))
  temp2 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*locf[, 2]^2*Kh(h[bd], x[i]-locf[,1])))
         if (temp0 ==0) {next}
       else {
       L1=L1+(locf[i, 2]-temp1/temp0)* Kh(h[bd], x[i] - locf[i, 1])
       L2=L2+(temp1^2-temp0*temp2)/((temp0)^2)* Kh(h[bd], x[i] - locf[i, 1])
       		}
       }
   }
 }
 beta.hat = beta0 - L1/L2
    if (abs(beta0-beta.hat)<10^-4)
    sign=1
    beta0=beta.hat
 }
betahat[bd] = beta0
 #beta0 = -0.03028778for weighted LOCF;
beta0 =0.01
sign = 0
while(sign ==0){
	L1 = 0
	L2 = 0
	for(i in 1:n){
		if ((cvlabel[i]==1)&&(num[i]>0)&&(delta[i]==1)&&(!is.na(ep[i,2]))){
			locf=fcova(i)
     if(locf[i,2]!=0){
  idcova=rep(0,n)
  idcova[locf[,2]!=0]=1
  temp0 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*idcova     *Kh(h[bd], x[i]-locf[,1])))
  temp1 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*locf[, 2]  *Kh(h[bd], x[i]-locf[,1])))
  temp2 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*locf[, 2]^2*Kh(h[bd], x[i]-locf[,1])))
         if (temp0 ==0) {next}
       else {
       L1=L1+(locf[i, 2]-temp1/temp0)* Kh(h[bd], x[i] - locf[i, 1])
       L2=L2+(temp1^2-temp0*temp2)/((temp0)^2)* Kh(h[bd], x[i] - locf[i, 1])
       		}
       				}
										}
				}
				beta.hat = beta0-L1/L2
				if (abs(beta0-beta.hat)<10^(04))
				sign = 1
				beta0 = beta.hat
			}
			betahat.1[bd] = beta0
			
	beta0 =0.01
sign = 0
while(sign ==0){
	L1 = 0
	L2 = 0
	for(i in 1:n){
		if ((cvlabel[i]==2)&&(num[i]>0)&&(delta[i]==1)&&(!is.na(ep[i,2]))){
			locf=fcova(i)
     if(locf[i,2]!=0){
  idcova=rep(0,n)
  idcova[locf[,2]!=0]=1
  temp0 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*idcova     *Kh(h[bd], x[i]-locf[,1])))
  temp1 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*locf[, 2]  *Kh(h[bd], x[i]-locf[,1])))
  temp2 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*locf[, 2]^2*Kh(h[bd], x[i]-locf[,1])))
         if (temp0 ==0) {next}
       else {
       L1=L1+(locf[i, 2]-temp1/temp0)* Kh(h[bd], x[i] - locf[i, 1])
       L2=L2+(temp1^2-temp0*temp2)/((temp0)^2)* Kh(h[bd], x[i] - locf[i, 1])
       		}
       				}
										}
				}
				beta.hat = beta0-L1/L2
				if (abs(beta0-beta.hat)<10^(04))
				sign = 1
				beta0 = beta.hat
			}
			betahat.2[bd] = beta0
		hatv[bd] = (betahat.1[bd] - betahat.2[bd])^2/4;
	print(bd)
	}
	
	slope = lm(betahat~h)$coef[2]
	mse = slope^2*h^2 + n*h*hatv
	opt_h = which(mse==min(mse[mse>0]))
	
	beta0 = 0.01
	sign=0
 while(sign==0){
 L1=0
 L2=0
 for (i in 1:n){
   if ((num[i]>0)&&(delta[i]==1)&&(!is.na(ep[i,2]))){
     locf=fcova(i)
     if(locf[i,2]!=0){
  idcova=rep(0,n)
  idcova[locf[,2]!=0]=1
  temp0 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*idcova     *Kh(h[opt_h], x[i]-locf[,1])))
  temp1 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*locf[, 2]  *Kh(h[opt_h], x[i]-locf[,1])))
  temp2 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*locf[, 2]^2*Kh(h[opt_h], x[i]-locf[,1])))
         if (temp0 ==0) {next}
       else {
       L1=L1+(locf[i, 2]-temp1/temp0)* Kh(h[opt_h], x[i] - locf[i, 1])
       L2=L2+(temp1^2-temp0*temp2)/((temp0)^2)* Kh(h[opt_h], x[i] - locf[i, 1])
       		}
       }
   }
 }
 beta.hat = beta0 - L1/L2
    if (abs(beta0-beta.hat)<10^-4)
    sign=1
    beta0=beta.hat
 }
beta0_opt = beta0
beta0_opt
 L11=0
 L2=0
 for (i in 1:n){
   if ((num[i]>0)&&(delta[i]==1)&&(!is.na(ep[i,2]))){
     locf2=fcova(i)
     if(locf2[i, 2]!=0){
  idcova2=rep(0,n)
  idcova2[locf2[,2]!=0]=1
  temp00 = (sum(yt(x,x[i])*exp(beta0_opt*locf2[,2])*idcova2     *Kh(h[opt_h], x[i]-locf2[,1])))
  temp11 = (sum(yt(x,x[i])*exp(beta0_opt*locf2[,2])*locf2[, 2]  *Kh(h[opt_h], x[i]-locf2[,1])))
  temp22 = (sum(yt(x,x[i])*exp(beta0_opt*locf2[,2])*locf2[, 2]^2*Kh(h[opt_h], x[i]-locf2[,1])))
       if (temp00==0) {next}
       else {
       L11=L11+((locf2[i, 2]-temp11/temp00) * Kh(h[opt_h], x[i] - locf2[i, 1]))^2
       L2=L2+(temp11^2-temp00*temp22)/((temp00)^2) * Kh(h[opt_h], x[i] - locf2[i, 1])
       		}
     }
   }
 }

 se=sqrt(L11/(L2^2))
 se
 beta0_opt/se
 # se = 0.01368814 for weighted LOCF;
 beta0 =0.01
 sign = 0
  while(sign==0){
 L1=0
 L2=0
 for (i in 1:n){
   if ((num[i]>0)&&(delta[i]==1)&&(!is.na(ep[i,2]))){
     locf=fcova(i)
     if(locf[i,2]!=0){
  idcova=rep(0,n)
  idcova[locf[,2]!=0]=1
  temp0 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*idcova     ))
  temp1 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*locf[, 2]  ))
  temp2 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*locf[, 2]^2))
         if (temp0 ==0) {next}
       else {
       L1=L1+(locf[i, 2]-temp1/temp0)
       L2=L2+(temp1^2-temp0*temp2)/((temp0)^2)
       		}
       }
   }
 }
 beta.hat = beta0 - L1/L2
    if (abs(beta0-beta.hat)<10^-4)
    sign=1
    beta0=beta.hat
 }
beta0
 #beta0 = -0.02828887 for LOCF;
 L11=0
 L2=0
 for (i in 1:n){
   if ((num[i]>0) &&(delta[i]==1)&&(!is.na(ep[i,2]))){
     locf2=fcova(i)
     if(locf2[i, 2]!=0){
  idcova2=rep(0,n)
  idcova2[locf2[,2]!=0]=1
  temp00 = (sum(yt(x,x[i])*exp(beta0*locf2[,2])*idcova2    ))
  temp11 = (sum(yt(x,x[i])*exp(beta0*locf2[,2])*locf2[, 2] ))
  temp22 = (sum(yt(x,x[i])*exp(beta0*locf2[,2])*locf2[, 2]^2))
       if (temp00==0) {next}
       else {
       L11=L11+((locf2[i, 2]-temp11/temp00) )^2
       L2=L2+(temp11^2-temp00*temp22)/((temp00)^2)
       		}
     }
   }
 }

 se=sqrt(L11/(L2^2))
 se
 # se = 0.01353788 for LOCF;
 beta0/se