rm(list=ls(all=TRUE))
#lamda=1,z(t)=t,beta=1
library(MASS)

inversef=function(u0,k0){
  step=rep(0,par)
  co=rcovariate[((k0-1)*par+1):(k0*par)]
  step[1]=a*exp(beta.real*co[1])*node[1]
  for(i in 2:par)
     step[i]=step[i-1]+a*exp(beta.real*co[i])/par
  temp=-log(u0)
  count=1
  while ((temp>step[count])&&(count<par)){
    count=count+1}
  if (count==1)
      return(temp/(a*exp(beta.real*co[1])))
  if(count>1)
      return((temp-step[count-1])/(a*exp(beta.real*co[count]))+node[count-1])
}
    
yt=function(x0,u0){
  y=x0
  y[u0<=x0]=1
  y[u0>x0]=0
  return(y)
}

Kh=function(h,t0){
  y=t0
  y[abs(t0/h)>=1]=0
  y[abs(t0/h)<1]=0.75*(1-(t0[abs(t0/h)<1]/h)^2)/h
  return(y)
}

s0=function(beta,k0,locf){
  idcova=rep(0,n)
  idcova[locf[,2]!=0]=1
  return(sum(yt(x,x[k0])*exp(beta*locf[,2])*idcova*Kh(h, x[k0]-locf[,1])))
}

s1=function(beta,k0,locf){
    return(sum(yt(x,x[k0])*exp(beta*locf[,2])*locf[,2] *Kh(h, x[k0]-locf[,1])))
}

s2=function(beta,k0,locf){
    return(sum(yt(x,x[k0])*exp(beta*locf[,2])*(locf[,2]^2)*Kh(h, x[k0]-locf[,1])))
}

fcova=function(i){
   cova=rep(0,n)
   cova_t = rep(0, n)
   for(j in 1:n){
        sik=observe[(ord[j]+1):(ord[j]+num[j])]
	  covariatei = covariate[(ord[j]+1):(ord[j]+num[j])]
	  sik[sik > x[i]] = -Inf
        neart = which.max(sik)
	  if (sik[neart]!=-Inf)
	  	{
           cova[j]=covariatei[neart] 
           cova_t[j] = sik[neart]
         }
   }
return(cbind(cova_t, cova))
}


f=function(beta){
 L1=0
 L2=0
 for (i in 1:n){
   if ((num[i]>0)&&(delta[i]==1)&&(x[i]<=tau)){
     locf=fcova(i)
     if(locf[i, 2]!=0){
       temp0=s0(beta,i,locf)
       temp1=s1(beta,i,locf)
       temp2=s2(beta,i,locf)
       if (temp0 ==0) {next}
       else {
       L1=L1+(locf[i,2]-temp1/temp0)* Kh(h, x[i] - locf[i,1])
       L2=L2+(temp1^2-temp0*temp2)/((temp0)^2)* Kh(h, x[i] - locf[i,1])
       		}
       }
   }
 }
 return(beta-L1/L2)
}

fse=function(beta){
 L11=0
 L2=0
 for (i in 1:n){
   if ((num[i]>0) &&(delta[i]==1)&&(x[i]<=tau)){
     locf=fcova(i)
     if(locf[i, 2]!=0){
       temp0=s0(beta,i,locf)
       temp1=s1(beta,i,locf)
       temp2=s2(beta,i,locf)
       if (temp0==0) {next}
       else {
       L11=L11+((locf[i, 2]-temp1/temp0)* Kh(h, x[i] - locf[i, 1]))^2
       L2=L2+(temp1^2-temp0*temp2)/((temp0)^2) * Kh(h, x[i] - locf[i, 1])
       		}
     }
   }
 }
 return(sqrt(L11/(L2^2)))
}


censoring=NULL
beta.h=NULL
se=NULL
indicator=NULL

a=2
tau=1
n=100
x=rep(0,n)
beta.real=1.5
par=20
node=seq(1/par,1,1/par)
const=5.1
lambda=8
h = n^(-0.7)
for(k in 1:5000){
  delta=rep(1,n)
  print(k)
  flag=0
  while (flag==0){
    u=runif(n)
    num=rpois(n,lambda-1)+1
    observe=runif(sum(num))
    ord=1:n
    ord[1]=0
    observe[1:num[1]]=sort(observe[1:num[1]])
    for(i in 2:n){
      ord[i]=sum(num[1:(i-1)])
      observe[(ord[i]+1):(ord[i]+num[i])]=sort(observe[(ord[i]+1):(ord[i]+num[i])])
    }
    covariate=rep(0,sum(num))
    mu=rep(0,par)
    sigma=rep(1,par)
    sigma=diag(sigma)
    for(j in 1:(par-1)){
       for(k in (j+1):par){
         sigma[j,k]=exp(-abs(j-k)/par)
         sigma[k,j]=sigma[j,k]
       }
    }
    rcovariate=mvrnorm(n,mu,sigma)
    rcovariate=t(rcovariate)
    rcovariate=as.vector(rcovariate)
    t=rep(0,n)
    for(i in 1:n){
      t[i]=inversef(u[i],i)
    }
    if (min(t)>min(observe))
      flag=1
 }

 for(i in 1:n){
   temp1=rcovariate[((i-1)*par+1):(i*par)]
   temp2=observe[(ord[i]+1):(ord[i]+num[i])]
   covariate[(ord[i]+1):(ord[i]+num[i])]=temp1[floor(temp2*par)+1]
 }
  censor=const*runif(n)
   x=t
  x[censor<t]=censor[censor<t]
  delta[censor<t]=0
  censoring=c(censoring,1-sum(delta)/n)

 #calculate beta.hat
 beta0=0.01
 sign=0
 while(sign==0){
 L1=0
 L2=0
 for (i in 1:n){
   if ((num[i]>0)&&(delta[i]==1)&&(x[i]<=tau)){
     locf=fcova(i)
     if(locf[i,2]!=0){
  idcova=rep(0,n)
  idcova[locf[,2]!=0]=1
  temp0 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*idcova     *Kh(h, x[i]-locf[,1])))
  temp1 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*locf[, 2]  *Kh(h, x[i]-locf[,1])))
  temp2 = (sum(yt(x,x[i])*exp(beta0*locf[,2])*locf[, 2]^2*Kh(h, x[i]-locf[,1])))
         if (temp0 ==0) {next}
       else {
       L1=L1+(locf[i, 2]-temp1/temp0)* Kh(h, x[i] - locf[i, 1])
       L2=L2+(temp1^2-temp0*temp2)/((temp0)^2)* Kh(h, x[i] - locf[i, 1])
       		}
       }
   }
 }
 beta.hat = beta0 - L1/L2
    if (abs(beta0-beta.hat)<10^-6)
    sign=1
    beta0=beta.hat
 }
 beta.h=c(beta.h,beta0)
 
 L11=0
 L2=0
 for (i in 1:n){
   if ((num[i]>0) &&(delta[i]==1)&&(x[i]<=tau)){
     locf2=fcova(i)
     if(locf2[i, 2]!=0){
  idcova2=rep(0,n)
  idcova2[locf2[,2]!=0]=1
  temp00 = (sum(yt(x,x[i])*exp(beta0*locf2[,2])*idcova2     *Kh(h, x[i]-locf2[,1])))
  temp11 = (sum(yt(x,x[i])*exp(beta0*locf2[,2])*locf2[, 2]  *Kh(h, x[i]-locf2[,1])))
  temp22 = (sum(yt(x,x[i])*exp(beta0*locf2[,2])*locf2[, 2]^2*Kh(h, x[i]-locf2[,1])))
       if (temp00==0) {next}
       else {
       L11=L11+((locf2[i, 2]-temp11/temp00) * Kh(h, x[i] - locf2[i, 1]))^2
       L2=L2+(temp11^2-temp00*temp22)/((temp00)^2) * Kh(h, x[i] - locf2[i, 1])
       		}
     }
   }
 }

 se=c(se,sqrt(L11/(L2^2)))
}

indicator=beta.h
indicator[abs(beta.h-beta.real)/se<=1.96]=1
indicator[abs(beta.h-beta.real)/se>1.96]=0
mean(indicator)*100
mean(se)
sqrt(var(beta.h))
mean(beta.h-beta.real)/beta.real
mean(beta.h-beta.real)
mean(censoring)
